<?php

namespace Drupal\appnexus;

/**
 * Generate parameters for apntag.setPageOpts() method.
 */
class PageOpts {

  protected $member;
  protected $quotes = TRUE;
  protected $keywords = [];

  public function setMember($id) {
    $this->member = $id;
    return $this;
  }

  public function getMember() {
    return (int) $this->member;
  }

  public function setKeywordQuotes($quotes = TRUE) {
    $this->quotes = $quotes;
    return $this;
  }

  public function getKeywordQuotes() {
    return (bool) $this->quotes;
  }

  public function setKeyword($key, $value) {
    if ($this->getKeywordQuotes()) {
      $this->keywords["'" . $key . "'"] = $value;
    }
    else {
      $this->keywords[$key] = $value;
    }
    return $this;
  }

  public function getKeywords() {
    return (array) $this->keywords;
  }

  public function build() {
    $opts = [];
    if ($member = $this->getMember()) {
      $opts['member'] = $member;
    }
    if ($keywords = $this->getKeywords()) {
      $opts['keywords'] = $keywords;
    }
    return $opts;
  }

}
