<?php

namespace Drupal\appnexus;

/**
 * Generate parameters for apntag.defineTag() method.
 */
class Tag {

  protected $tagId;
  protected $sizes = [];
  protected $targetId;

  public function setTagId($id) {
    $this->tagId = $id;
    return $this;
  }

  public function getTagId() {
    return (int) $this->tagId;
  }

  public function setSizes($sizes) {
    $this->sizes = $sizes;
    return $this;
  }

  public function getSizes() {
    $sizes = [];
    $pair = explode(',', strtolower($this->sizes));
    if (count($pair)) {
      foreach ($pair as $size) {
        $sizes[] = explode('x', $size);
      }
    }
    else {
      $sizes = explode('x', $pair);
    }
    return (array) $sizes;
  }

  public function setTargetId($id) {
    $this->targetId = $id;
    return $this;
  }

  public function getTargetId() {
    return $this->targetId;
  }

  public function build() {
    $opts = [];
    if ($tagId = $this->getTagId()) {
      $opts['tagId'] = $tagId;
    }
    if ($sizes = $this->getSizes()) {
      $opts['sizes'] = $sizes;
    }
    if ($targetId = $this->getTargetId()) {
      $opts['targetId'] = $targetId;
    }
    return $opts;
  }

}
